<template>
    <div class="channels">
        <div class="header-page">
            <div class="title">Доступные каналы</div>
            <div class="options">
                <select-part :list="ChannelsGenres" :choosen="chooseGenre.title" :routeType="'ChannelsList'" @choose="onChoose" ></select-part>
                <input type="text" class="search-film" placeholder="Найти канал" v-model="search"/>
            </div>
        </div>
        <div class="body-page">
            <div v-if="isLoaded" class="loading-container" style="height: 70vh">
                <div class="loading-box"></div>
            </div>
            <div v-else>
                <channels-list v-if="channels" :channels="filteredChannels"></channels-list>
                <div class="empty" v-else>
                    Empty
                </div>
            </div>
        </div>

    </div>
</template>

<script>
    import ChannelsList from '@/components/channels/list'
    import SelectPart from  '../../components/select'

    export default {
        name: "index",
        components: {ChannelsList,SelectPart},
        data() {
            return {
                search: '',
                chooseGenre: {id:'All', title: 'Все'}
            }
        },
        computed: {
            channels() {
                return this.$store.getters.getChannels ? this.$store.getters.getChannels : null
            },
            isLoaded() {
                return this.$store.getters.isLoading('channels');
            },
            ChannelsGenres () {
                return this.$store.getters.getChannelsGenres
            },
            filterGenres() {
                if (this.chooseGenre.id !== 'All') {
                    if (this.chooseGenre.id === 'favorite') {
                        return this.channels.filter(film => film.favorite === 1);
                    } else if ( this.chooseGenre.id === 'top' ) {
                        return this.$store.getters.getTopChannels;
                    } else {
                        return this.channels.filter(channel => channel.genre_id === this.chooseGenre.id)
                    }
                }
                else {
                    return this.channels;
                }

            },
            filteredChannels() {
                return this.filterGenres.filter((channel) => {
                    return channel ? channel.name.toLowerCase().match(this.search.toLowerCase()) : {}
                });
            },
        },
        methods: {
            onChoose (data) {
                this.chooseGenre = data
            }
        },
        beforeMount() {
            if (!this.$store.state.channels_ids.length > 0 || !this.$store.state.channelsGenres_ids.length > 0 || !this.$store.state.top_channels_ids.length > 0) {
                this.$store.dispatch('loadIndexChannels')
            }

            this.chooseGenre = this.$route.params.genreFilter ?  this.$route.params.genreFilter : {id: "All", title: "Все"};
        }
    }
</script>

<style scoped>

    .search-film {
        width: 260px;
        border: 0;
        line-height: 40px;
        padding: 0 15px;
        background: #ffffff;
        height: 40px;
        border-radius: 5px;
        font-size: 15px;
    }
    .pagination {
        display: flex;
        align-items: center;
        justify-content: space-between;
        margin-top: 20px;
    }
    .pagination .pagination-btn {
        width: 180px;
    }
    .pagination .pagination-btn > div {
        padding: 10px 20px;
        border: 1px solid #f1f1f1;
        cursor: pointer;
    }
    .pagination .pagination-btn:last-child  {
        text-align: right;
    }
    .list-page {
        display: flex;
        align-items: center;
    }
    .list-page > li .btn {
        padding: 5px 15px !important;
        border: 1px solid #f1f1f1;
        cursor: pointer;
        margin: 0 5px;
    }
    .list-page > li .btn.active {
        opacity: .5;
    }

    @media (max-width: 1000px) {
        .pagination .pagination-btn {
            width: 0;
        }
        .pagination .pagination-btn .btn {
            display: none;
        }
    }

    .options {
        display: flex;
        align-items: center;
    }


    @media (max-width: 930px) {
        .header-page {
            flex-wrap: wrap;
            height: initial !important;
        }
        .header-page .title{
            width: 100%;
            margin-bottom: 10px;
        }

        .header-page .options {
            width: 100%;
        }
        .header-page .options .select-part {
            min-width: calc(50% - 5px);
            max-width: calc(50% - 5px);
            margin: 0 5px 0 0;
        }
        .header-page .options input {
            min-width: calc(50% - 5px) !important;
            max-width: calc(50% - 5px) !important;
            margin-right: 0;
            margin-left: 5px;
        }
    }
    @media (max-width: 550px) {
        .header-page .options {
            flex-wrap: wrap;
        }
        .header-page .options > div,
        .header-page .options > input {
            margin: 0 0 10px !important;
            min-width: 100% !important;
            max-width: 100% !important;
        }
    }
</style>
